import scrapy


#scrapy crawl noticias -t json --nolog -o noticias.json -a year=2016 month=12 day=24

import re

TAG_RE = re.compile(r'<[^>]+>')
def remove_tags(text):
        return TAG_RE.sub('', text)

class NoticiasItem(scrapy.Item):
        title = scrapy.Field()
        text = scrapy.Field()
        date = scrapy.Field()
        location = scrapy.Field()
        author = scrapy.Field()
        topic = scrapy.Field()
        url = scrapy.Field()

class QuotesSpider(scrapy.Spider):
	name = "noticias"
	def start_requests(self):
		year = getattr(self, 'year', None)
		month = getattr(self, 'month', None)
		day = getattr(self, 'day', None)
		self.baseURL='http://yucatan.com.mx/'+year+'/'+month+'/'+day
		urls = [
			self.baseURL,
                ]
		for url in urls:
			yield scrapy.Request(url=url, callback=self.parse)

	def parse(self, response):
		pages = response.css("div.pagination").css("a::attr(href)")[-1].extract()
		pages =  int(pages[pages.rfind('/')+1:])
		for p in range(0,pages):
			yield scrapy.Request(url=response.url+"/page/"+str(p+1), callback=self.parse_page)

	def parse_page(self, response):
		for link in response.css("div.bp-head").css("h2").css("a::attr(href)").extract():
			yield scrapy.Request(url=link, callback=self.parse_item)

	def parse_item(self, response):
		item = NoticiasItem()
		item['title'] = response.css("h1.entry-title::text").extract_first()
		item['date'] = response.css("div.base-box").css("span.entry-date::attr(datetime)").extract_first()
		item['text'] = response.css("div.entry-content").css("p::text").extract()
		item['url'] = response.url
		yield item

